"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.repo = exports.fin = exports.init = exports.test = exports.suite = exports.macro = exports.workflow = exports.simple = exports.call = exports.run = exports.conf = exports.version = exports.catalog = exports.runner = undefined;

var _dogmalangmin = require("dogmalangmin");

var _justo = require("justo.task");

let creator;
var runner = null;exports.runner = runner;

var catalog = null;exports.catalog = catalog;

const version = _dogmalangmin.dogma.use(require("../package")).version;exports.version = version;

function conf(config) {
  /* istanbul ignore next */_dogmalangmin.dogma.paramExpected("config", config, _dogmalangmin.map);{
    exports.runner = runner = _dogmalangmin.dogma.use(require(config.runner.impl))(config);creator = (0, _justo.Creator)(runner);exports.catalog = catalog = (0, _justo.Catalog)(creator);
  }
}exports.conf = conf;

function run(task, params) {
  /* istanbul ignore next */_dogmalangmin.dogma.paramExpected("task", task, null);{
    return runner.run(task, params);
  }
}exports.run = run;

function call(...args) {
  {
    return creator.call(...args);
  }
}exports.call = call;

function simple(...args) {
  {
    return creator.simple(...args);
  }
}exports.simple = simple;

function workflow(...args) {
  {
    return creator.workflow(...args);
  }
}exports.workflow = workflow;

function macro(...args) {
  {
    return creator.macro(...args);
  }
}exports.macro = macro;

function suite(...args) {
  {
    return creator.suite(...args);
  }
}exports.suite = suite;

suite.only = (...args) => {
  let task;{
    task = creator.suite(...args);task.only();
  }return task;
};
suite.skip = (...args) => {
  let task;{
    let opts = _dogmalangmin.dogma.getItem(args, 0);if (_dogmalangmin.dogma.is(opts, _dogmalangmin.text)) {
      opts = { ["id"]: opts, ["when"]: false };
    } else if (_dogmalangmin.dogma.is(opts, _dogmalangmin.map)) {
      opts = _dogmalangmin.dogma.clone(opts, { "when": false }, {}, [], []);
    }task = creator.suite(opts, ..._dogmalangmin.dogma.getSlice(args, 1, -1));
  }return task;
};
function test(...args) {
  {
    return creator.test(...args);
  }
}exports.test = test;

test.only = (...args) => {
  let task;{
    task = creator.test(...args);task.only();
  }return task;
};
test.skip = (...args) => {
  let task;{
    task = creator.test(...args);task.skip();
  }return task;
};
function init(...args) {
  {
    return creator.init(...args);
  }
}exports.init = init;

init.skip = (...args) => {
  let task;{
    task = creator.init(...args);task.skip();
  }return task;
};
function fin(...args) {
  {
    return creator.fin(...args);
  }
}exports.fin = fin;

fin.skip = (...args) => {
  let task;{
    task = creator.fin(...args);task.skip();
  }return task;
};
function repo(...args) {
  {
    return runner.repo.def(...args);
  }
}exports.repo = repo;

repo.get = (...args) => {
  {
    return runner.repo.get(...args);
  }
};
repo.set = (...args) => {
  {
    return runner.repo.set(...args);
  }
};